diff -r fc7b8711dba0 qpy/QtCore/qpycore_qobject_helpers.cpp
--- a/qpy/QtCore/qpycore_qobject_helpers.cpp	Sat Oct 05 16:44:56 2013 +0100
+++ b/qpy/QtCore/qpycore_qobject_helpers.cpp	Mon Oct 07 13:33:22 2013 +0100
@@ -211,6 +211,7 @@
 
     SIP_BLOCK_THREADS
 
+    PyTypeObject *base_pytype = sipTypeAsPyTypeObject(base);
     PyObject *mro = Py_TYPE(pySelf)->tp_mro;
 
     for (SIP_SSIZE_T i = 0; i < PyTuple_GET_SIZE(mro); ++i)
@@ -224,7 +225,10 @@
 
         if (qstrcmp(pytype->tp_name, _clname) == 0)
         {
-            if (td == base)
+            // The generated type definitions represent the C++ (rather than
+            // Python) hierachy.  If the C++ hierachy doesn't match then the
+            // super-type must be provided by a mixin.
+            if (PyType_IsSubtype(base_pytype, pytype))
                 *sipCpp = sipGetAddress(pySelf);
             else
                 *sipCpp = sipGetMixinAddress(pySelf, td);